# redis

## 启动

```
C:\Program Files\Redis>redisredis-server.exe redis.windows.conf
PS C:\Users\fengchun_yuan> redis-cli.exe

```

![image-20210917160229829]( ./redis_string了解学习.assets/image-20210917160229829.png)

### string

![image-20210917160325607]( .\redis_string了解学习.assets\image-20210917160325607.png)

这是最简单的string类型。
这种类型，Redis就像一个可以持久化的memcached服务器（注：memcache的数据仅保存在内存中，服务器重启后，数据将丢失）。

## Redis 命令

下文中key，一般情况下均关联value

1. DEL  key 删除key，key存在，就返回1，key不存在，返回0
2. DUMP 序列化，将value转成字节
   ![image-20211018171806273]( .\redis_string了解学习.assets\image-20211018171806273.png)
3. EXISTS 检查key是否存在，存在返回1，不存在返回0
4. EXPIRE 对key设置过期时间，以秒为单位
5. EXPIREAT 以UNIX时间戳（unix timestamp）格式设置key的过期时间
6. EXPIREAT 对key设置过期时间，以毫秒为单位
7. PATTERN 查找所有符合模式pattern的key
8. MOVE 将key移动指定数据库    redis默认使用数据库0，即 redis  > ...          redis:数据库名称（默认为0不显示）
9. PERSIST 移除key的过期时间，使其永不过期   移出成功，返回1；若eky不存在或者没设置过期时间，返回0
10. PTTL 以毫秒为单位返回key的剩余过期时间。 key不存在，返回-2；key存在但没设置剩余生存时间，返回-1
11. TTL 以秒为单位……
12. RANDOMKEY 从当前数据库中随机返回一个key
13. RENAME 修改key的名称。改名成功时候返回ok，失败时返回error。当old_key_name与new_key_name相同，或者old_key_name不存在时，返回error。当new_key_name已经存在时，进行重命名，new_key_name原先的value会被旧的覆盖
14. RENAMENX 修改key的名（当且仅当new_key_name不存在）。修改成功，返回1。若new_key_name已经存在，返回0；若old_key_name或new_key_name都不存在，返回0

### String部分

1. GETRANGE 获取存在指定key中的子字符串，截取范围由start和end两个偏移量决定（包括start和end）
2. GETSET
